/*
 * Unique Schlüssel für JPA Entität
 */
package de.ivu.elect.business.stimmzettel.entity;
import java.util.function.Function;
import java.util.ArrayList;
import java.util.stream.Collectors;

@javax.enterprise.inject.Vetoed
public class StimmzettelUK
implements de.ivu.elect.jee.entity.tk.EntityUK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

    protected final java.lang.String nummer;

    public java.lang.String getNummer(){
      return nummer;
    }

  protected final de.ivu.elect.business.gebietsbaum.entity.GebietUK gebietUK;

    public de.ivu.elect.business.gebietsbaum.entity.GebietUK getGebietUK(){
      return gebietUK;
    }

  public StimmzettelUK(
java.lang.String nummer
,   de.ivu.elect.business.gebietsbaum.entity.GebietUK gebietUK
  ) {
    super();


      this.nummer = nummer;
        this.gebietUK = gebietUK;
    }

  @Override
  public int hashCode() {
        int result = 1;
    
    
                    result = result + ((nummer == null) ? 0 : nummer.hashCode());
        
                    result = result + ((gebietUK == null) ? 0 : gebietUK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    
    if (getClass() != obj.getClass()) {
      return false;
    }

            StimmzettelUK other = (StimmzettelUK) obj;

                if (nummer == null) {
          if (other.nummer != null) {
            return false;
          }
        } else if (!nummer.equals(other.nummer)) {
          return false;
        }
        
                if (gebietUK == null) {
          if (other.gebietUK != null) {
            return false;
          }
        } else if (!gebietUK.equals(other.gebietUK)) {
          return false;
        }
            
    return true;
  }

  @Override
  public String getEntityMessageKey() {
    return StimmzettelConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(gebietUK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(StimmzettelConstants.MESSAGE_KEY_ENTITY_EINZAHL, StimmzettelConstants.MESSAGE_KEY_NUMMER_EINZAHL, nummer));
        
        return result;
      }
  
    @Override
  public String toString() {
    return "StimmzettelUK[" + toStringParameter() + "]";
  }

            protected String toStringParameter() {
              String result = ""

                                                        +"nummer="+nummer
                                        +", "                +"gebietUK="+gebietUK
                        ;
                          return result;
            
            }




          public String allUKFields() {
    return String.join(", ", getAllUKFieldValues().stream()
         .map(object -> (object != null ? object.toString() : null))
         .collect(Collectors.toList()));
    }

   protected ArrayList<Object> getAllUKFieldValues() {
              ArrayList<Object> list = new ArrayList<>();
              list.add(nummer);
     return list;
   }

            public static <E extends Stimmzettel> java.util.Map<StimmzettelUK, E> mappeStimmzettelNachUK(java.util.Collection<E> entities) {

                return entities.stream().collect(java.util.stream.Collectors.toMap(Stimmzettel::getStimmzettelUK, Function.<E>identity(), (u,v)->v));
             }


                public static Function<Stimmzettel, StimmzettelUK> getStimmzettelToUKFunction() {
                return Stimmzettel::getStimmzettelUK;
                }

}
